package pwc.taxtech.atms.common.schedule;

import org.apache.log4j.Logger;
import pwc.taxtech.atms.dto.RequestParameterDto;
import pwc.taxtech.atms.entity.Organization;
import pwc.taxtech.atms.entity.OrganizationAccountingRate;
import pwc.taxtech.atms.service.impl.AnalysisJobServiceImpl;
import java.util.List;
import java.util.Map;

/**
 * @version 1.0
 * @program: atms
 * @description: analysis 初始化
 * @author: Kevin
 * @create: 2019-04-17 23:06
 **/
public class AnalysisMasterInit implements Runnable {
    public static final Logger logger = Logger.getLogger(AnalysisMasterInit.class);
    private AnalysisJobServiceImpl analysisJobService;
    List<pwc.taxtech.atms.entity.Organization> orgs;
    Organization o;
    Integer period;
    Map<String, String> areaMap;
    java.util.Map<String, String> buMap;
    Map<String, String> regionMap;
    List<OrganizationAccountingRate> rates;
    public AnalysisMasterInit(AnalysisJobServiceImpl analysisJobService, List<Organization> orgs, Organization o, Integer period, Map<String, String> areaMap, Map<String, String> buMap, Map<String, String> regionMap, List<OrganizationAccountingRate> rates) {
        this.analysisJobService = analysisJobService;
        this.orgs = orgs;
        this.o = o;
        this.period = period;
        this.areaMap = areaMap;
        this.buMap = buMap;
        this.regionMap = regionMap;
        this.rates = rates;
    }

    @Override
    public void run() {
        try {
            analysisJobService.master(orgs, o, period, areaMap, buMap, regionMap, rates);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
